import greenfoot.*;
/**
 * My own version of the vector class, also stores points.
 * Use:
 * store the point (100, 635) would look like:
 * PointVector p = new PointVector(100, 635);
 * getting the value of the x or y would look like:
 * p.x   //no parenthesis needed like p.x()
 * p.y   //same no parenthesis
 * 
 * @author Phoenix Johnson
 * @version 1.1
 */
public class PointVector extends Actor
{
    int timer = 0;
    int rad;
    double x, y, z;   //creates x, y, and z variables
    double r, aXY, aXZ;   //creates variables for 3d polar points
    int newX, newY;
    public PointVector(int x, int y) {
        this.x = x;
        this.y = y;
    }
    public PointVector(int x, int y, double z) {
        this.x = x;
        this.y = y;
        this.z = z;
    }
    public PointVector(double r, double angle) {
        this.r = r;
        aXY = angle;
    }
    public PointVector(double r, double aXY, double aXZ) {
        this.r = r;
        aXY = aXY;
    }
    public PointVector() {   
    }
    
    public void act() {
        fall();
    }
    
    public void fall() {
        int turnSpeed = 0;
        int pfallspeed = 4;
        int nfallspeed = -4;
        if (x <= getWorld().getWidth()/2) {
            newX = (int) (z*nfallspeed);
            if (y <= getWorld().getHeight()/2) {
                newY = (int) (z*nfallspeed);
            } else {
                newY = (int) (z*pfallspeed);
            }
        } else {
            newX = (int) (z*pfallspeed);
            if (y <= getWorld().getHeight()/2) {
                newY = (int) (z*nfallspeed);
            } else {
                newY = (int) (z*pfallspeed);
            }
        }
        setLocation(newX+getX(), newY+getY());
        if (timer == Greenfoot.getRandomNumber(1000)+450) {
            while (turnSpeed != 0) {
                turnSpeed = Greenfoot.getRandomNumber(30)-15;
            }
            turn(turnSpeed);
        } else {
            timer++;
        }
        //move((int)(Math.sqrt((newX-x)*(newX-x)+(newY-y)*(newY-y))/1000));
        move(Math.round((float)Math.pow(z, 1.4)*4));
        setImg();
        z += 0.002;
    }
    
    protected void addedToWorld(World world) {
        setImg();
        turn(Greenfoot.getRandomNumber(360)-180);
        fall();
    }
    
    public void setImg() {
        GreenfootImage img = new GreenfootImage("Point.png");
        rad = Math.round((float)z*16);
        //System.out.println(r);
        img.scale(rad, rad);
        setImage(img);
    }
    
    public void translate(int x, int y) {
        this.x += x;
        this.y += y;
    }
    
    public void scale(double factor) {
        r = r*factor;
    }
    
    public void invertX() {
        x = -x;
    }
    public void invertY() {
        y = -y;
    }
    public void invertZ() {
        z = -z;
    }
    
    public void sphericalToCartesian() {
        r = Math.sqrt((x*x)+(y*y)+(z*z));
        aXY = Math.atan(y/x);
        aXZ = Math.acos(z/r);
    }
    public void CartesianToSpherical() {
        x = r*Math.sin(aXY)*Math.cos(aXZ);
        y = r*Math.sin(aXY)*Math.sin(aXZ);
        z = r*Math.cos(aXY);
    }
}
